%define enable_fips 1
%define fipscheck_version 1.2.0
%define libgcrypt_version 1.4.5
%define device_mapper_version 1.02.61

Summary: A utility for setting up encrypted filesystems
Name: cryptsetup-luks
Version: 1.2.0
Release: 7%{?dist}
License: GPLv2
Group: Applications/System
URL: http://cryptsetup.googlecode.com/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: libgcrypt-devel >= %{libgcrypt_version}
BuildRequires: device-mapper-devel >= %{device_mapper_version}
BuildRequires: libgpg-error-devel, libuuid-devel, libsepol-devel
BuildRequires: libselinux-devel, popt-devel
%if %{enable_fips}
BuildRequires: fipscheck-devel >= %{fipscheck_version}
%endif
Provides: cryptsetup = %{version}-%{release}
Obsoletes: cryptsetup <= 0.1
Requires: cryptsetup-luks-libs = %{version}-%{release}

%define _root_sbindir /sbin
%define upstream_version %{version}
Source0: http://cryptsetup.googlecode.com/files/cryptsetup-%{upstream_version}.tar.bz2
Patch0: cryptsetup-crypto-backend.patch
Patch1: cryptsetup-fipscheck.patch
Patch2: cryptsetup-1.3.2-status.patch
Patch3: cryptsetup-1.3.3-fix-device-lookup.patch
Patch4: cryptsetup-1.4.1-fix-duplicate-status.patch

%description
This package contains cryptsetup, a utility for setting up
encrypted filesystems using Device Mapper and the dm-crypt target.

%package devel
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: libgcrypt-devel >= %{libgcrypt_version}
Requires: device-mapper-devel >= %{device_mapper_version}
Requires: pkgconfig, libuuid-devel
Summary: Headers and libraries for using encrypted filesystems

%description devel
The cryptsetup-luks-devel package contain libraries and header files
used for writing code that makes use of encrypted filesystems.

%package libs
Group: System Environment/Libraries
Summary: Cryptsetup shared library
Requires: device-mapper-libs >= %{device_mapper_version}

%description libs
This package contains the cryptsetup shared library, libcryptsetup.

%prep
%setup -q -n cryptsetup-%{upstream_version}
%patch0 -p1
%if %{enable_fips}
%patch1 -p1
%endif
%patch2 -p1
%patch3 -p1
%patch4 -p1

iconv -f latin1 -t utf8 ChangeLog > ChangeLog.new
mv -f ChangeLog.new ChangeLog 

%build
%configure  --sbindir=%{_root_sbindir} --libdir=/%{_lib}

# remove rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
make %{?_smp_mflags}

%if %{enable_fips}
# Generate HMAC checksums
%define __spec_install_post \
  %{?__debug_package:%{__debug_install_post}} \
  %{__arch_install_post} \
  %{__os_install_post} \
  fipshmac $RPM_BUILD_ROOT/%{_root_sbindir}/cryptsetup \
  fipshmac $RPM_BUILD_ROOT/%{_lib}/libcryptsetup.so.*
%endif

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
rm -rf  $RPM_BUILD_ROOT/%{_lib}/*.la $RPM_BUILD_ROOT/%{_lib}/cryptsetup

# move libcryptsetup.so to %%{_libdir}
pushd $RPM_BUILD_ROOT/%{_lib}
rm libcryptsetup.so
mkdir -p $RPM_BUILD_ROOT/%{_libdir}
ln -s ../../%{_lib}/$(ls libcryptsetup.so.?.?.?) $RPM_BUILD_ROOT/%{_libdir}/libcryptsetup.so
mv $RPM_BUILD_ROOT/%{_lib}/pkgconfig $RPM_BUILD_ROOT/%{_libdir}
popd 
%find_lang cryptsetup

%post -n cryptsetup-luks-libs -p /sbin/ldconfig

%postun -n cryptsetup-luks-libs -p /sbin/ldconfig

%files -f cryptsetup.lang
%defattr(-,root,root,-)
%doc COPYING ChangeLog AUTHORS TODO FAQ
%{_mandir}/man8/cryptsetup.8.gz
%{_root_sbindir}/cryptsetup
%if %{enable_fips}
%{_root_sbindir}/.cryptsetup.hmac
%endif

%files devel
%defattr(-,root,root,-)
%{_includedir}/libcryptsetup.h
%{_libdir}/libcryptsetup.so
%{_libdir}/pkgconfig/libcryptsetup.pc

%files libs
%defattr(-,root,root,-)
/%{_lib}/libcryptsetup.so.*
%if %{enable_fips}
/%{_lib}/.libcryptsetup.so.*.hmac
%endif

%clean
rm -rf $RPM_BUILD_ROOT


%changelog

